/**
 * @license React
 * react-dom-server-legacy.node.production.min.js
 *
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/*


 JS Implementation of MurmurHash3 (r136) (as of May 20, 2011)

 Copyright (c) 2011 Gary Court
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.
*/
'use strict';var ca=require("next/dist/compiled/react-experimental"),ha=require("react-dom"),ia=require("stream");
function ja(a,b){var c=a.length&3;var d=a.length-c;var e=b;for(b=0;b<d;){var f=a.charCodeAt(b)&255|(a.charCodeAt(++b)&255)<<8|(a.charCodeAt(++b)&255)<<16|(a.charCodeAt(++b)&255)<<24;++b;f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295;f=f<<15|f>>>17;f=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295;e^=f;e=e<<13|e>>>19;e=5*(e&65535)+((5*(e>>>16)&65535)<<16)&4294967295;e=(e&65535)+27492+(((e>>>16)+58964&65535)<<16)}f=0;switch(c){case 3:f^=(a.charCodeAt(b+2)&255)<<
16;case 2:f^=(a.charCodeAt(b+1)&255)<<8;case 1:f^=a.charCodeAt(b)&255,f=3432918353*(f&65535)+((3432918353*(f>>>16)&65535)<<16)&4294967295,f=f<<15|f>>>17,e^=461845907*(f&65535)+((461845907*(f>>>16)&65535)<<16)&4294967295}e^=a.length;e^=e>>>16;e=2246822507*(e&65535)+((2246822507*(e>>>16)&65535)<<16)&4294967295;e^=e>>>13;e=3266489909*(e&65535)+((3266489909*(e>>>16)&65535)<<16)&4294967295;return(e^e>>>16)>>>0}
var r=Object.assign,w=Object.prototype.hasOwnProperty,va=RegExp("^[:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD][:A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040]*$"),wa={},xa={};
function ya(a){if(w.call(xa,a))return!0;if(w.call(wa,a))return!1;if(va.test(a))return xa[a]=!0;wa[a]=!0;return!1}
var za=new Set("animationIterationCount aspectRatio borderImageOutset borderImageSlice borderImageWidth boxFlex boxFlexGroup boxOrdinalGroup columnCount columns flex flexGrow flexPositive flexShrink flexNegative flexOrder gridArea gridRow gridRowEnd gridRowSpan gridRowStart gridColumn gridColumnEnd gridColumnSpan gridColumnStart fontWeight lineClamp lineHeight opacity order orphans scale tabSize widows zIndex zoom fillOpacity floodOpacity stopOpacity strokeDasharray strokeDashoffset strokeMiterlimit strokeOpacity strokeWidth MozAnimationIterationCount MozBoxFlex MozBoxFlexGroup MozLineClamp msAnimationIterationCount msFlex msZoom msFlexGrow msFlexNegative msFlexOrder msFlexPositive msFlexShrink msGridColumn msGridColumnSpan msGridRow msGridRowSpan WebkitAnimationIterationCount WebkitBoxFlex WebKitBoxFlexGroup WebkitBoxOrdinalGroup WebkitColumnCount WebkitColumns WebkitFlex WebkitFlexGrow WebkitFlexPositive WebkitFlexShrink WebkitLineClamp".split(" ")),Aa=
new Map([["acceptCharset","accept-charset"],["htmlFor","for"],["httpEquiv","http-equiv"],["crossOrigin","crossorigin"],["accentHeight","accent-height"],["alignmentBaseline","alignment-baseline"],["arabicForm","arabic-form"],["baselineShift","baseline-shift"],["capHeight","cap-height"],["clipPath","clip-path"],["clipRule","clip-rule"],["colorInterpolation","color-interpolation"],["colorInterpolationFilters","color-interpolation-filters"],["colorProfile","color-profile"],["colorRendering","color-rendering"],
["dominantBaseline","dominant-baseline"],["enableBackground","enable-background"],["fillOpacity","fill-opacity"],["fillRule","fill-rule"],["floodColor","flood-color"],["floodOpacity","flood-opacity"],["fontFamily","font-family"],["fontSize","font-size"],["fontSizeAdjust","font-size-adjust"],["fontStretch","font-stretch"],["fontStyle","font-style"],["fontVariant","font-variant"],["fontWeight","font-weight"],["glyphName","glyph-name"],["glyphOrientationHorizontal","glyph-orientation-horizontal"],["glyphOrientationVertical",
"glyph-orientation-vertical"],["horizAdvX","horiz-adv-x"],["horizOriginX","horiz-origin-x"],["imageRendering","image-rendering"],["letterSpacing","letter-spacing"],["lightingColor","lighting-color"],["markerEnd","marker-end"],["markerMid","marker-mid"],["markerStart","marker-start"],["overlinePosition","overline-position"],["overlineThickness","overline-thickness"],["paintOrder","paint-order"],["panose-1","panose-1"],["pointerEvents","pointer-events"],["renderingIntent","rendering-intent"],["shapeRendering",
"shape-rendering"],["stopColor","stop-color"],["stopOpacity","stop-opacity"],["strikethroughPosition","strikethrough-position"],["strikethroughThickness","strikethrough-thickness"],["strokeDasharray","stroke-dasharray"],["strokeDashoffset","stroke-dashoffset"],["strokeLinecap","stroke-linecap"],["strokeLinejoin","stroke-linejoin"],["strokeMiterlimit","stroke-miterlimit"],["strokeOpacity","stroke-opacity"],["strokeWidth","stroke-width"],["textAnchor","text-anchor"],["textDecoration","text-decoration"],
["textRendering","text-rendering"],["transformOrigin","transform-origin"],["underlinePosition","underline-position"],["underlineThickness","underline-thickness"],["unicodeBidi","unicode-bidi"],["unicodeRange","unicode-range"],["unitsPerEm","units-per-em"],["vAlphabetic","v-alphabetic"],["vHanging","v-hanging"],["vIdeographic","v-ideographic"],["vMathematical","v-mathematical"],["vectorEffect","vector-effect"],["vertAdvY","vert-adv-y"],["vertOriginX","vert-origin-x"],["vertOriginY","vert-origin-y"],
["wordSpacing","word-spacing"],["writingMode","writing-mode"],["xmlnsXlink","xmlns:xlink"],["xHeight","x-height"]]),Ha=/["'&<>]/;
function x(a){if("boolean"===typeof a||"number"===typeof a)return""+a;a=""+a;var b=Ha.exec(a);if(b){var c="",d,e=0;for(d=b.index;d<a.length;d++){switch(a.charCodeAt(d)){case 34:b="&quot;";break;case 38:b="&amp;";break;case 39:b="&#x27;";break;case 60:b="&lt;";break;case 62:b="&gt;";break;default:continue}e!==d&&(c+=a.slice(e,d));e=d+1;c+=b}a=e!==d?c+a.slice(e,d):c}return a}
var Ia=/([A-Z])/g,Ja=/^ms-/,Ka=Array.isArray,La=ca.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,Ma={pending:!1,data:null,method:null,action:null},Na=ha.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.Dispatcher,lb={prefetchDNS:Oa,preconnect:fb,preload:gb,preloadModule:hb,preinitStyle:ib,preinitScript:jb,preinitModuleScript:kb},y=[];
function mb(a,b){var c=0;void 0!==b&&(c=1);return{idPrefix:void 0===a?"":a,nextFormID:0,streamingFormat:c,instructions:0,hasBody:!1,hasHtml:!1,unknownResources:{},dnsResources:{},connectResources:{default:{},anonymous:{},credentials:{}},imageResources:{},styleResources:{},scriptResources:{},moduleUnknownResources:{},moduleScriptResources:{}}}function F(a,b,c){return{insertionMode:a,selectedValue:b,tagScope:c}}
function nb(a){return F("http://www.w3.org/2000/svg"===a?3:"http://www.w3.org/1998/Math/MathML"===a?4:0,null,0)}
function ob(a,b,c){switch(b){case "noscript":return F(2,null,a.tagScope|1);case "select":return F(2,null!=c.value?c.value:c.defaultValue,a.tagScope);case "svg":return F(3,null,a.tagScope);case "picture":return F(2,null,a.tagScope|2);case "math":return F(4,null,a.tagScope);case "foreignObject":return F(2,null,a.tagScope);case "table":return F(5,null,a.tagScope);case "thead":case "tbody":case "tfoot":return F(6,null,a.tagScope);case "colgroup":return F(8,null,a.tagScope);case "tr":return F(7,null,a.tagScope)}return 5<=
a.insertionMode?F(2,null,a.tagScope):0===a.insertionMode?"html"===b?F(1,null,a.tagScope):F(2,null,a.tagScope):1===a.insertionMode?F(2,null,a.tagScope):a}var pb=new Map;
function Ab(a,b){if("object"!==typeof b)throw Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");var c=!0,d;for(d in b)if(w.call(b,d)){var e=b[d];if(null!=e&&"boolean"!==typeof e&&""!==e){if(0===d.indexOf("--")){var f=x(d);e=x((""+e).trim())}else f=pb.get(d),void 0===f&&(f=x(d.replace(Ia,"-$1").toLowerCase().replace(Ja,"-ms-")),pb.set(d,f)),e="number"===typeof e?0===e||za.has(d)?""+e:e+"px":
x((""+e).trim());c?(c=!1,a.push(' style="',f,":",e)):a.push(";",f,":",e)}}c||a.push('"')}function Bb(a,b,c){c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""')}function G(a,b,c){"function"!==typeof c&&"symbol"!==typeof c&&"boolean"!==typeof c&&a.push(" ",b,'="',x(c),'"')}function Cb(a){var b=a.nextFormID++;return a.idPrefix+b}var Db=x("javascript:throw new Error('A React form was unexpectedly submitted.')");
function Eb(a,b){this.push('<input type="hidden"');if("string"!==typeof a)throw Error("File/Blob fields are not yet supported in progressive forms. It probably means you are closing over binary data or FormData in a Server Action.");G(this,"name",b);G(this,"value",a);this.push("/>")}
function Fb(a,b,c,d,e,f,g,h){var k=null;"function"===typeof d&&("function"===typeof d.$$FORM_ACTION?(e=Cb(b),b=d.$$FORM_ACTION(e),h=b.name,d=b.action||"",e=b.encType,f=b.method,g=b.target,k=b.data):(a.push(" ","formAction",'="',Db,'"'),g=f=e=d=h=null,Gb(b,c)));null!=h&&H(a,"name",h);null!=d&&H(a,"formAction",d);null!=e&&H(a,"formEncType",e);null!=f&&H(a,"formMethod",f);null!=g&&H(a,"formTarget",g);return k}
function H(a,b,c){switch(b){case "className":G(a,"class",c);break;case "tabIndex":G(a,"tabindex",c);break;case "dir":case "role":case "viewBox":case "width":case "height":G(a,b,c);break;case "style":Ab(a,c);break;case "src":case "href":if(""===c)break;case "action":case "formAction":if(null==c||"function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ",b,'="',x(""+c),'"');break;case "defaultValue":case "defaultChecked":case "innerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":break;
case "autoFocus":case "multiple":case "muted":Bb(a,b.toLowerCase(),c);break;case "xlinkHref":if("function"===typeof c||"symbol"===typeof c||"boolean"===typeof c)break;a.push(" ","xlink:href",'="',x(""+c),'"');break;case "contentEditable":case "spellCheck":case "draggable":case "value":case "autoReverse":case "externalResourcesRequired":case "focusable":case "preserveAlpha":"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',x(c),'"');break;case "allowFullScreen":case "async":case "autoPlay":case "controls":case "default":case "defer":case "disabled":case "disablePictureInPicture":case "disableRemotePlayback":case "formNoValidate":case "hidden":case "loop":case "noModule":case "noValidate":case "open":case "playsInline":case "readOnly":case "required":case "reversed":case "scoped":case "seamless":case "itemScope":c&&
"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'=""');break;case "capture":case "download":!0===c?a.push(" ",b,'=""'):!1!==c&&"function"!==typeof c&&"symbol"!==typeof c&&a.push(" ",b,'="',x(c),'"');break;case "cols":case "rows":case "size":case "span":"function"!==typeof c&&"symbol"!==typeof c&&!isNaN(c)&&1<=c&&a.push(" ",b,'="',x(c),'"');break;case "rowSpan":case "start":"function"===typeof c||"symbol"===typeof c||isNaN(c)||a.push(" ",b,'="',x(c),'"');break;case "xlinkActuate":G(a,"xlink:actuate",
c);break;case "xlinkArcrole":G(a,"xlink:arcrole",c);break;case "xlinkRole":G(a,"xlink:role",c);break;case "xlinkShow":G(a,"xlink:show",c);break;case "xlinkTitle":G(a,"xlink:title",c);break;case "xlinkType":G(a,"xlink:type",c);break;case "xmlBase":G(a,"xml:base",c);break;case "xmlLang":G(a,"xml:lang",c);break;case "xmlSpace":G(a,"xml:space",c);break;default:if(!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1])if(b=Aa.get(b)||b,ya(b)){switch(typeof c){case "function":case "symbol":return;
case "boolean":var d=b.toLowerCase().slice(0,5);if("data-"!==d&&"aria-"!==d)return}a.push(" ",b,'="',x(c),'"')}}}function J(a,b,c){if(null!=b){if(null!=c)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof b||!("__html"in b))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");b=b.__html;null!==b&&void 0!==b&&a.push(""+b)}}
function Hb(a){var b="";ca.Children.forEach(a,function(c){null!=c&&(b+=c)});return b}
function Gb(a,b){0!==(a.instructions&16)||b.externalRuntimeScript||(a.instructions|=16,b.bootstrapChunks.unshift(b.startInlineScript,'addEventListener("submit",function(a){if(!a.defaultPrevented){var c=a.target,d=a.submitter,e=c.action,b=d;if(d){var f=d.getAttribute("formAction");null!=f&&(e=f,b=null)}"javascript:throw new Error(\'A React form was unexpectedly submitted.\')"===e&&(a.preventDefault(),b?(a=document.createElement("input"),a.name=b.name,a.value=b.value,b.parentNode.insertBefore(a,b),b=new FormData(c),a.parentNode.removeChild(a)):b=new FormData(c),a=c.getRootNode(),(a.$$reactFormReplay=a.$$reactFormReplay||[]).push(c,\nd,b))}});',"\x3c/script>"))}
function Ib(a,b,c,d,e,f,g){var h=b.rel,k=b.href,l=b.precedence;if(3===f||g||null!=b.itemProp||"string"!==typeof h||"string"!==typeof k||""===k)return K(a,b),null;if("stylesheet"===b.rel){if("string"!==typeof l||null!=b.disabled||b.onLoad||b.onError)return K(a,b);f=d.styles.get(l);g=c.styleResources.hasOwnProperty(k)?c.styleResources[k]:void 0;null!==g?(c.styleResources[k]=null,f||(f={precedence:x(l),rules:[],hrefs:[],sheets:new Map},d.styles.set(l,f)),b={state:0,props:r({},b,{"data-precedence":b.precedence,
precedence:null})},g&&(2===g.length&&Jb(b.props,g),(c=d.preloads.stylesheets.get(k))&&0<c.length?c.length=0:b.state=1),f.sheets.set(k,b),d.boundaryResources&&d.boundaryResources.stylesheets.add(b)):f&&(k=f.sheets.get(k))&&d.boundaryResources&&d.boundaryResources.stylesheets.add(k);e&&a.push("\x3c!-- --\x3e");return null}if(b.onLoad||b.onError)return K(a,b);e&&a.push("\x3c!-- --\x3e");switch(b.rel){case "preconnect":case "dns-prefetch":return K(d.preconnectChunks,b);case "preload":return K(d.preloadChunks,
b);default:return K(d.hoistableChunks,b)}}function K(a,b){a.push(L("link"));for(var c in b)if(w.call(b,c)){var d=b[c];if(null!=d)switch(c){case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:H(a,c,d)}}a.push("/>");return null}
function Kb(a,b,c){a.push(L(c));for(var d in b)if(w.call(b,d)){var e=b[d];if(null!=e)switch(d){case "children":case "dangerouslySetInnerHTML":throw Error(c+" is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");default:H(a,d,e)}}a.push("/>");return null}
function Lb(a,b){a.push(L("title"));var c=null,d=null,e;for(e in b)if(w.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:H(a,e,f)}}a.push(">");b=Array.isArray(c)?2>c.length?c[0]:null:c;"function"!==typeof b&&"symbol"!==typeof b&&null!==b&&void 0!==b&&a.push(x(""+b));J(a,d,c);a.push(Mb("title"));return null}
function Nb(a,b){a.push(L("script"));var c=null,d=null,e;for(e in b)if(w.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:H(a,e,f)}}a.push(">");J(a,d,c);"string"===typeof c&&a.push(x(c));a.push(Mb("script"));return null}
function Ob(a,b,c){a.push(L(c));var d=c=null,e;for(e in b)if(w.call(b,e)){var f=b[e];if(null!=f)switch(e){case "children":c=f;break;case "dangerouslySetInnerHTML":d=f;break;default:H(a,e,f)}}a.push(">");J(a,d,c);return"string"===typeof c?(a.push(x(c)),null):c}var Pb=/^[a-zA-Z][a-zA-Z:_\.\-\d]*$/,Qb=new Map;function L(a){var b=Qb.get(a);if(void 0===b){if(!Pb.test(a))throw Error("Invalid tag: "+a);b="<"+a;Qb.set(a,b)}return b}
function Rb(a,b,c,d,e,f,g){switch(b){case "div":case "span":case "svg":case "path":case "a":case "g":case "p":case "li":break;case "select":a.push(L("select"));var h=null,k=null,l;for(l in c)if(w.call(c,l)){var n=c[l];if(null!=n)switch(l){case "children":h=n;break;case "dangerouslySetInnerHTML":k=n;break;case "defaultValue":case "value":break;default:H(a,l,n)}}a.push(">");J(a,k,h);return h;case "option":var q=f.selectedValue;a.push(L("option"));var m=null,B=null,C=null,P=null,u;for(u in c)if(w.call(c,
u)){var z=c[u];if(null!=z)switch(u){case "children":m=z;break;case "selected":C=z;break;case "dangerouslySetInnerHTML":P=z;break;case "value":B=z;default:H(a,u,z)}}if(null!=q){var p=null!==B?""+B:Hb(m);if(Ka(q))for(var Z=0;Z<q.length;Z++){if(""+q[Z]===p){a.push(' selected=""');break}}else""+q===p&&a.push(' selected=""')}else C&&a.push(' selected=""');a.push(">");J(a,P,m);return m;case "textarea":a.push(L("textarea"));var t=null,T=null,D=null,A;for(A in c)if(w.call(c,A)){var v=c[A];if(null!=v)switch(A){case "children":D=
v;break;case "value":t=v;break;case "defaultValue":T=v;break;case "dangerouslySetInnerHTML":throw Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");default:H(a,A,v)}}null===t&&null!==T&&(t=T);a.push(">");if(null!=D){if(null!=t)throw Error("If you supply `defaultValue` on a <textarea>, do not pass children.");if(Ka(D)){if(1<D.length)throw Error("<textarea> can only have at most one child.");t=""+D[0]}t=""+D}"string"===typeof t&&"\n"===t[0]&&a.push("\n");null!==t&&a.push(x(""+t));
return null;case "input":a.push(L("input"));var Pa=null,qb=null,Ba=null,ka=null,da=null,U=null,Qa=null,Ra=null,Sa=null,la;for(la in c)if(w.call(c,la)){var N=c[la];if(null!=N)switch(la){case "children":case "dangerouslySetInnerHTML":throw Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");case "name":Pa=N;break;case "formAction":qb=N;break;case "formEncType":Ba=N;break;case "formMethod":ka=N;break;case "formTarget":da=N;break;case "defaultChecked":Sa=
N;break;case "defaultValue":Qa=N;break;case "checked":Ra=N;break;case "value":U=N;break;default:H(a,la,N)}}var rb=Fb(a,d,e,qb,Ba,ka,da,Pa);null!==Ra?Bb(a,"checked",Ra):null!==Sa&&Bb(a,"checked",Sa);null!==U?H(a,"value",U):null!==Qa&&H(a,"value",Qa);a.push("/>");null!==rb&&rb.forEach(Eb,a);return null;case "button":a.push(L("button"));var ma=null,na=null,aa=null,oa=null,pa=null,Ta=null,qa=null,Ua;for(Ua in c)if(w.call(c,Ua)){var ba=c[Ua];if(null!=ba)switch(Ua){case "children":ma=ba;break;case "dangerouslySetInnerHTML":na=
ba;break;case "name":aa=ba;break;case "formAction":oa=ba;break;case "formEncType":pa=ba;break;case "formMethod":Ta=ba;break;case "formTarget":qa=ba;break;default:H(a,Ua,ba)}}var Sc=Fb(a,d,e,oa,pa,Ta,qa,aa);a.push(">");null!==Sc&&Sc.forEach(Eb,a);J(a,na,ma);if("string"===typeof ma){a.push(x(ma));var Tc=null}else Tc=ma;return Tc;case "form":a.push(L("form"));var Va=null,Uc=null,ea=null,Wa=null,Xa=null,Ya=null,Za;for(Za in c)if(w.call(c,Za)){var fa=c[Za];if(null!=fa)switch(Za){case "children":Va=fa;
break;case "dangerouslySetInnerHTML":Uc=fa;break;case "action":ea=fa;break;case "encType":Wa=fa;break;case "method":Xa=fa;break;case "target":Ya=fa;break;default:H(a,Za,fa)}}var Yb=null,Zb=null;if("function"===typeof ea)if("function"===typeof ea.$$FORM_ACTION){var Ce=Cb(d),Ca=ea.$$FORM_ACTION(Ce);ea=Ca.action||"";Wa=Ca.encType;Xa=Ca.method;Ya=Ca.target;Yb=Ca.data;Zb=Ca.name}else a.push(" ","action",'="',Db,'"'),Ya=Xa=Wa=ea=null,Gb(d,e);null!=ea&&H(a,"action",ea);null!=Wa&&H(a,"encType",Wa);null!=
Xa&&H(a,"method",Xa);null!=Ya&&H(a,"target",Ya);a.push(">");null!==Zb&&(a.push('<input type="hidden"'),G(a,"name",Zb),a.push("/>"),null!==Yb&&Yb.forEach(Eb,a));J(a,Uc,Va);if("string"===typeof Va){a.push(x(Va));var Vc=null}else Vc=Va;return Vc;case "menuitem":a.push(L("menuitem"));for(var sb in c)if(w.call(c,sb)){var Wc=c[sb];if(null!=Wc)switch(sb){case "children":case "dangerouslySetInnerHTML":throw Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");default:H(a,sb,Wc)}}a.push(">");
return null;case "title":if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var Xc=Lb(a,c);else Lb(e.hoistableChunks,c),Xc=null;return Xc;case "link":return Ib(a,c,d,e,g,f.insertionMode,!!(f.tagScope&1));case "script":var $b=c.async;if("string"!==typeof c.src||!c.src||!$b||"function"===typeof $b||"symbol"===typeof $b||c.onLoad||c.onError||3===f.insertionMode||f.tagScope&1||null!=c.itemProp)var Yc=Nb(a,c);else{var tb=c.src;if("module"===c.type){var ub=d.moduleScriptResources;var Zc=e.preloads.moduleScripts}else ub=
d.scriptResources,Zc=e.preloads.scripts;var vb=ub.hasOwnProperty(tb)?ub[tb]:void 0;if(null!==vb){ub[tb]=null;var ac=c;if(vb){2===vb.length&&(ac=r({},c),Jb(ac,vb));var $c=Zc.get(tb);$c&&($c.length=0)}var ad=[];e.scripts.add(ad);Nb(ad,ac)}g&&a.push("\x3c!-- --\x3e");Yc=null}return Yc;case "style":var wb=c.precedence,ra=c.href;if(3===f.insertionMode||f.tagScope&1||null!=c.itemProp||"string"!==typeof wb||"string"!==typeof ra||""===ra){a.push(L("style"));var Da=null,bd=null,$a;for($a in c)if(w.call(c,
$a)){var xb=c[$a];if(null!=xb)switch($a){case "children":Da=xb;break;case "dangerouslySetInnerHTML":bd=xb;break;default:H(a,$a,xb)}}a.push(">");var ab=Array.isArray(Da)?2>Da.length?Da[0]:null:Da;"function"!==typeof ab&&"symbol"!==typeof ab&&null!==ab&&void 0!==ab&&a.push(x(""+ab));J(a,bd,Da);a.push(Mb("style"));var cd=null}else{var sa=e.styles.get(wb);if(null!==(d.styleResources.hasOwnProperty(ra)?d.styleResources[ra]:void 0)){d.styleResources[ra]=null;sa?sa.hrefs.push(x(ra)):(sa={precedence:x(wb),
rules:[],hrefs:[x(ra)],sheets:new Map},e.styles.set(wb,sa));var dd=sa.rules,Ea=null,ed=null,yb;for(yb in c)if(w.call(c,yb)){var bc=c[yb];if(null!=bc)switch(yb){case "children":Ea=bc;break;case "dangerouslySetInnerHTML":ed=bc}}var bb=Array.isArray(Ea)?2>Ea.length?Ea[0]:null:Ea;"function"!==typeof bb&&"symbol"!==typeof bb&&null!==bb&&void 0!==bb&&dd.push(x(""+bb));J(dd,ed,Ea)}sa&&e.boundaryResources&&e.boundaryResources.styles.add(sa);g&&a.push("\x3c!-- --\x3e");cd=void 0}return cd;case "meta":if(3===
f.insertionMode||f.tagScope&1||null!=c.itemProp)var fd=Kb(a,c,"meta");else g&&a.push("\x3c!-- --\x3e"),fd="string"===typeof c.charSet?Kb(e.charsetChunks,c,"meta"):"viewport"===c.name?Kb(e.preconnectChunks,c,"meta"):Kb(e.hoistableChunks,c,"meta");return fd;case "listing":case "pre":a.push(L(b));var cb=null,db=null,eb;for(eb in c)if(w.call(c,eb)){var zb=c[eb];if(null!=zb)switch(eb){case "children":cb=zb;break;case "dangerouslySetInnerHTML":db=zb;break;default:H(a,eb,zb)}}a.push(">");if(null!=db){if(null!=
cb)throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");if("object"!==typeof db||!("__html"in db))throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");var ta=db.__html;null!==ta&&void 0!==ta&&("string"===typeof ta&&0<ta.length&&"\n"===ta[0]?a.push("\n",ta):a.push(""+ta))}"string"===typeof cb&&"\n"===cb[0]&&a.push("\n");return cb;case "img":var I=c.src,
E=c.srcSet;if(!("lazy"===c.loading||!I&&!E||"string"!==typeof I&&null!=I||"string"!==typeof E&&null!=E)&&"low"!==c.fetchPriority&&!1===!!(f.tagScope&2)&&("string"!==typeof I||":"!==I[4]||"d"!==I[0]&&"D"!==I[0]||"a"!==I[1]&&"A"!==I[1]||"t"!==I[2]&&"T"!==I[2]||"a"!==I[3]&&"A"!==I[3])&&("string"!==typeof E||":"!==E[4]||"d"!==E[0]&&"D"!==E[0]||"a"!==E[1]&&"A"!==E[1]||"t"!==E[2]&&"T"!==E[2]||"a"!==E[3]&&"A"!==E[3])){var gd="string"===typeof c.sizes?c.sizes:void 0,Fa=E?E+"\n"+(gd||""):I,cc=e.preloads.images,
ua=cc.get(Fa);if(ua){if("high"===c.fetchPriority||10>e.highImagePreloads.size)cc.delete(Fa),e.highImagePreloads.add(ua)}else if(!d.imageResources.hasOwnProperty(Fa)){d.imageResources[Fa]=y;var dc=c.crossOrigin;var hd="string"===typeof dc?"use-credentials"===dc?dc:"":void 0;var V=e.headers,ec;V&&0<V.remainingCapacity&&("high"===c.fetchPriority||500>V.highImagePreloads.length)&&(ec=Sb(I,"image",{imageSrcSet:c.srcSet,imageSizes:c.sizes,crossOrigin:hd,integrity:c.integrity,nonce:c.nonce,type:c.type,fetchPriority:c.fetchPriority,
referrerPolicy:c.refererPolicy}),2<=(V.remainingCapacity-=ec.length))?(e.resets.image[Fa]=y,V.highImagePreloads&&(V.highImagePreloads+=", "),V.highImagePreloads+=ec):(ua=[],K(ua,{rel:"preload",as:"image",href:E?void 0:I,imageSrcSet:E,imageSizes:gd,crossOrigin:hd,integrity:c.integrity,type:c.type,fetchPriority:c.fetchPriority,referrerPolicy:c.referrerPolicy}),"high"===c.fetchPriority||10>e.highImagePreloads.size?e.highImagePreloads.add(ua):(e.bulkPreloads.add(ua),cc.set(Fa,ua)))}}return Kb(a,c,"img");
case "base":case "area":case "br":case "col":case "embed":case "hr":case "keygen":case "param":case "source":case "track":case "wbr":return Kb(a,c,b);case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":break;case "head":if(2>f.insertionMode&&null===e.headChunks){e.headChunks=[];var id=Ob(e.headChunks,c,"head")}else id=Ob(a,c,"head");return id;case "html":if(0===f.insertionMode&&null===
e.htmlChunks){e.htmlChunks=[""];var jd=Ob(e.htmlChunks,c,"html")}else jd=Ob(a,c,"html");return jd;default:if(-1!==b.indexOf("-")){a.push(L(b));var fc=null,kd=null,Ga;for(Ga in c)if(w.call(c,Ga)){var Q=c[Ga];if(null!=Q){var ld=Ga;switch(Ga){case "children":fc=Q;break;case "dangerouslySetInnerHTML":kd=Q;break;case "style":Ab(a,Q);break;case "suppressContentEditableWarning":case "suppressHydrationWarning":break;case "className":ld="class";default:if(ya(Ga)&&"function"!==typeof Q&&"symbol"!==typeof Q&&
!1!==Q){if(!0===Q)Q="";else if("object"===typeof Q)continue;a.push(" ",ld,'="',x(Q),'"')}}}}a.push(">");J(a,kd,fc);return fc}}return Ob(a,c,b)}var Tb=new Map;function Mb(a){var b=Tb.get(a);void 0===b&&(b="</"+a+">",Tb.set(a,b));return b}function Ub(a,b){b=b.bootstrapChunks;for(var c=0;c<b.length-1;c++)a.push(b[c]);return c<b.length?(c=b[c],b.length=0,a.push(c)):!0}
function Vb(a,b,c){a.push('\x3c!--$?--\x3e<template id="');if(null===c)throw Error("An ID must have been assigned before we can complete the boundary.");a.push(b.boundaryPrefix);b=c.toString(16);a.push(b);return a.push('"></template>')}
function Wb(a,b,c,d){switch(c.insertionMode){case 0:case 1:case 2:return a.push('<div hidden id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 3:return a.push('<svg aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 4:return a.push('<math aria-hidden="true" style="display:none" id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 5:return a.push('<table hidden id="'),a.push(b.segmentPrefix),
b=d.toString(16),a.push(b),a.push('">');case 6:return a.push('<table hidden><tbody id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 7:return a.push('<table hidden><tr id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');case 8:return a.push('<table hidden><colgroup id="'),a.push(b.segmentPrefix),b=d.toString(16),a.push(b),a.push('">');default:throw Error("Unknown insertion mode. This is a bug in React.");}}
function Xb(a,b){switch(b.insertionMode){case 0:case 1:case 2:return a.push("</div>");case 3:return a.push("</svg>");case 4:return a.push("</math>");case 5:return a.push("</table>");case 6:return a.push("</tbody></table>");case 7:return a.push("</tr></table>");case 8:return a.push("</colgroup></table>");default:throw Error("Unknown insertion mode. This is a bug in React.");}}var gc=/[<\u2028\u2029]/g;
function hc(a){return JSON.stringify(a).replace(gc,function(b){switch(b){case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var ic=/[&><\u2028\u2029]/g;
function jc(a){return JSON.stringify(a).replace(ic,function(b){switch(b){case "&":return"\\u0026";case ">":return"\\u003e";case "<":return"\\u003c";case "\u2028":return"\\u2028";case "\u2029":return"\\u2029";default:throw Error("escapeJSObjectForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}})}var kc=!1,lc=!0;
function mc(a){var b=a.rules,c=a.hrefs,d=0;if(c.length){this.push('<style media="not all" data-precedence="');this.push(a.precedence);for(this.push('" data-href="');d<c.length-1;d++)this.push(c[d]),this.push(" ");this.push(c[d]);this.push('">');for(d=0;d<b.length;d++)this.push(b[d]);lc=this.push("</style>");kc=!0;b.length=0;c.length=0}}function nc(a){return 2!==a.state?kc=!0:!1}function oc(a,b,c){kc=!1;lc=!0;b.styles.forEach(mc,a);b.stylesheets.forEach(nc);kc&&(c.stylesToHoist=!0);return lc}
function M(a){for(var b=0;b<a.length;b++)this.push(a[b]);a.length=0}var pc=[];function qc(a){K(pc,a.props);for(var b=0;b<pc.length;b++)this.push(pc[b]);pc.length=0;a.state=2}
function rc(a){var b=0<a.sheets.size;a.sheets.forEach(qc,this);a.sheets.clear();var c=a.rules,d=a.hrefs;if(!b||d.length){this.push('<style data-precedence="');this.push(a.precedence);a=0;if(d.length){for(this.push('" data-href="');a<d.length-1;a++)this.push(d[a]),this.push(" ");this.push(d[a])}this.push('">');for(a=0;a<c.length;a++)this.push(c[a]);this.push("</style>");c.length=0;d.length=0}}
function sc(a){if(0===a.state){a.state=1;var b=a.props;K(pc,{rel:"preload",as:"style",href:a.props.href,crossOrigin:b.crossOrigin,fetchPriority:b.fetchPriority,integrity:b.integrity,media:b.media,hrefLang:b.hrefLang,referrerPolicy:b.referrerPolicy});for(a=0;a<pc.length;a++)this.push(pc[a]);pc.length=0}}function tc(a){a.sheets.forEach(sc,this);a.sheets.clear()}
function uc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=jc(""+d.props.href),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=jc(""+d.props.href);a.push(g);e=""+e;a.push(",");e=jc(e);a.push(e);for(var h in f)if(w.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!ya(h))break a;g=""+g}e.push(",");k=jc(k);e.push(k);e.push(",");g=
jc(g);e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}
function vc(a,b){a.push("[");var c="[";b.stylesheets.forEach(function(d){if(2!==d.state)if(3===d.state)a.push(c),d=x(JSON.stringify(""+d.props.href)),a.push(d),a.push("]"),c=",[";else{a.push(c);var e=d.props["data-precedence"],f=d.props,g=x(JSON.stringify(""+d.props.href));a.push(g);e=""+e;a.push(",");e=x(JSON.stringify(e));a.push(e);for(var h in f)if(w.call(f,h)&&(g=f[h],null!=g))switch(h){case "href":case "rel":case "precedence":case "data-precedence":break;case "children":case "dangerouslySetInnerHTML":throw Error("link is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
default:a:{e=a;var k=h.toLowerCase();switch(typeof g){case "function":case "symbol":break a}switch(h){case "innerHTML":case "dangerouslySetInnerHTML":case "suppressContentEditableWarning":case "suppressHydrationWarning":case "style":break a;case "className":k="class";g=""+g;break;case "hidden":if(!1===g)break a;g="";break;case "src":case "href":g=""+g;break;default:if(2<h.length&&("o"===h[0]||"O"===h[0])&&("n"===h[1]||"N"===h[1])||!ya(h))break a;g=""+g}e.push(",");k=x(JSON.stringify(k));e.push(k);
e.push(",");g=x(JSON.stringify(g));e.push(g)}}a.push("]");c=",[";d.state=3}});a.push("]")}
function Oa(a){var b=O?O:null;if(b){var c=b.resumableState,d=b.renderState;if("string"===typeof a&&a){if(!c.dnsResources.hasOwnProperty(a)){c.dnsResources[a]=null;c=d.headers;var e,f;if(f=c&&0<c.remainingCapacity)f=(e="<"+(""+a).replace(wc,xc)+">; rel=dns-prefetch",2<=(c.remainingCapacity-=e.length));f?(d.resets.dns[a]=null,c.preconnects&&(c.preconnects+=", "),c.preconnects+=e):(e=[],K(e,{href:a,rel:"dns-prefetch"}),d.preconnects.add(e))}yc(b)}}}
function fb(a,b){var c=O?O:null;if(c){var d=c.resumableState,e=c.renderState;if("string"===typeof a&&a){var f="use-credentials"===b?"credentials":"string"===typeof b?"anonymous":"default";if(!d.connectResources[f].hasOwnProperty(a)){d.connectResources[f][a]=null;d=e.headers;var g,h;if(h=d&&0<d.remainingCapacity){h="<"+(""+a).replace(wc,xc)+">; rel=preconnect";if("string"===typeof b){var k=(""+b).replace(zc,Ac);h+='; crossorigin="'+k+'"'}h=(g=h,2<=(d.remainingCapacity-=g.length))}h?(e.resets.connect[f][a]=
null,d.preconnects&&(d.preconnects+=", "),d.preconnects+=g):(f=[],K(f,{rel:"preconnect",href:a,crossOrigin:b}),e.preconnects.add(f))}yc(c)}}}
function gb(a,b,c){var d=O?O:null;if(d){var e=d.resumableState,f=d.renderState;if(b&&a){switch(b){case "image":if(c){var g=c.imageSrcSet;var h=c.imageSizes;var k=c.fetchPriority}var l=g?g+"\n"+(h||""):a;if(e.imageResources.hasOwnProperty(l))return;e.imageResources[l]=y;e=f.headers;var n;e&&0<e.remainingCapacity&&"high"===k&&(n=Sb(a,b,c),2<=(e.remainingCapacity-=n.length))?(f.resets.image[l]=y,e.highImagePreloads&&(e.highImagePreloads+=", "),e.highImagePreloads+=n):(e=[],K(e,r({rel:"preload",href:g?
void 0:a,as:b},c)),"high"===k?f.highImagePreloads.add(e):(f.bulkPreloads.add(e),f.preloads.images.set(l,e)));break;case "style":if(e.styleResources.hasOwnProperty(a))return;g=[];K(g,r({rel:"preload",href:a,as:b},c));e.styleResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?y:[c.crossOrigin,c.integrity];f.preloads.stylesheets.set(a,g);f.bulkPreloads.add(g);break;case "script":if(e.scriptResources.hasOwnProperty(a))return;g=[];f.preloads.scripts.set(a,g);f.bulkPreloads.add(g);
K(g,r({rel:"preload",href:a,as:b},c));e.scriptResources[a]=!c||"string"!==typeof c.crossOrigin&&"string"!==typeof c.integrity?y:[c.crossOrigin,c.integrity];break;default:if(e.unknownResources.hasOwnProperty(b)){if(g=e.unknownResources[b],g.hasOwnProperty(a))return}else g={},e.unknownResources[b]=g;g[a]=y;if((e=f.headers)&&0<e.remainingCapacity&&"font"===b&&(l=Sb(a,b,c),2<=(e.remainingCapacity-=l.length)))f.resets.font[a]=y,e.fontPreloads&&(e.fontPreloads+=", "),e.fontPreloads+=l;else switch(e=[],
a=r({rel:"preload",href:a,as:b},c),K(e,a),b){case "font":f.fontPreloads.add(e);break;default:f.bulkPreloads.add(e)}}yc(d)}}}
function hb(a,b){var c=O?O:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=b&&"string"===typeof b.as?b.as:"script";switch(f){case "script":if(d.moduleScriptResources.hasOwnProperty(a))return;f=[];d.moduleScriptResources[a]=!b||"string"!==typeof b.crossOrigin&&"string"!==typeof b.integrity?y:[b.crossOrigin,b.integrity];e.preloads.moduleScripts.set(a,f);break;default:if(d.moduleUnknownResources.hasOwnProperty(f)){var g=d.unknownResources[f];if(g.hasOwnProperty(a))return}else g={},d.moduleUnknownResources[f]=
g;f=[];g[a]=y}K(f,r({rel:"modulepreload",href:a},b));e.bulkPreloads.add(f);yc(c)}}}
function ib(a,b,c){var d=O?O:null;if(d){var e=d.resumableState,f=d.renderState;if(a){b=b||"default";var g=f.styles.get(b),h=e.styleResources.hasOwnProperty(a)?e.styleResources[a]:void 0;null!==h&&(e.styleResources[a]=null,g||(g={precedence:x(b),rules:[],hrefs:[],sheets:new Map},f.styles.set(b,g)),b={state:0,props:r({rel:"stylesheet",href:a,"data-precedence":b},c)},h&&(2===h.length&&Jb(b.props,h),(f=f.preloads.stylesheets.get(a))&&0<f.length?f.length=0:b.state=1),g.sheets.set(a,b),yc(d))}}}
function jb(a,b){var c=O?O:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.scriptResources.hasOwnProperty(a)?d.scriptResources[a]:void 0;null!==f&&(d.scriptResources[a]=null,b=r({src:a,async:!0},b),f&&(2===f.length&&Jb(b,f),a=e.preloads.scripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Nb(a,b),yc(c))}}}
function kb(a,b){var c=O?O:null;if(c){var d=c.resumableState,e=c.renderState;if(a){var f=d.moduleScriptResources.hasOwnProperty(a)?d.moduleScriptResources[a]:void 0;null!==f&&(d.moduleScriptResources[a]=null,b=r({src:a,type:"module",async:!0},b),f&&(2===f.length&&Jb(b,f),a=e.preloads.moduleScripts.get(a))&&(a.length=0),a=[],e.scripts.add(a),Nb(a,b),yc(c))}}}function Jb(a,b){null==a.crossOrigin&&(a.crossOrigin=b[0]);null==a.integrity&&(a.integrity=b[1])}
function Sb(a,b,c){a=(""+a).replace(wc,xc);b=(""+b).replace(zc,Ac);b="<"+a+'>; rel=preload; as="'+b+'"';for(var d in c)w.call(c,d)&&(a=c[d],"string"===typeof a&&(b+="; "+d.toLowerCase()+'="'+(""+a).replace(zc,Ac)+'"'));return b}var wc=/[<>\r\n]/g;
function xc(a){switch(a){case "<":return"%3C";case ">":return"%3E";case "\n":return"%0A";case "\r":return"%0D";default:throw Error("escapeLinkHrefForHeaderContextReplacer encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}}var zc=/["';,\r\n]/g;
function Ac(a){switch(a){case '"':return"%22";case "'":return"%27";case ";":return"%3B";case ",":return"%2C";case "\n":return"%0A";case "\r":return"%0D";default:throw Error("escapeStringForLinkHeaderQuotedParamValueContextReplacer encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");}}function Bc(a){this.styles.add(a)}function Cc(a){this.stylesheets.add(a)}
function Dc(a,b,c){if(b=a.onHeaders){var d=a.headers;if(d){var e=d.preconnects;d.fontPreloads&&(e&&(e+=", "),e+=d.fontPreloads);d.highImagePreloads&&(e&&(e+=", "),e+=d.highImagePreloads);if(!c){c=a.styles.values();var f=c.next();a:for(;0<d.remainingCapacity&&!f.done;f=c.next()){f=f.value.sheets.values();for(var g=f.next();0<d.remainingCapacity&&!g.done;g=f.next()){var h=g.value;g=h.props;var k=g.href;h=h.props;h=Sb(h.href,"style",{crossOrigin:h.crossOrigin,integrity:h.integrity,nonce:h.nonce,type:h.type,
fetchPriority:h.fetchPriority,referrerPolicy:h.referrerPolicy,media:h.media});if(2<=(d.remainingCapacity-=h.length))a.resets.style[k]=y,e&&(e+=", "),e+=h,a.resets.style[k]="string"===typeof g.crossOrigin||"string"===typeof g.integrity?[g.crossOrigin,g.integrity]:y;else break a}}}e?b({Link:e}):b({});a.headers=null}}}
function Ec(a,b){var c=a.idPrefix;a=c+"P:";var d=c+"S:";c+="B:";var e=new Set,f=new Set,g=new Set,h=new Map,k=new Set,l=new Set,n=new Set,q={images:new Map,stylesheets:new Map,scripts:new Map,moduleScripts:new Map};return{placeholderPrefix:a,segmentPrefix:d,boundaryPrefix:c,startInlineScript:"<script>",htmlChunks:null,headChunks:null,externalRuntimeScript:null,bootstrapChunks:[],onHeaders:void 0,headers:null,resets:{font:{},dns:{},connect:{default:{},anonymous:{},credentials:{}},image:{},style:{}},
charsetChunks:[],preconnectChunks:[],importMapChunks:[],preloadChunks:[],hoistableChunks:[],preconnects:e,fontPreloads:f,highImagePreloads:g,styles:h,bootstrapScripts:k,scripts:l,bulkPreloads:n,preloads:q,boundaryResources:null,stylesToHoist:!1,generateStaticMarkup:b}}function Fc(a,b,c,d){if(c.generateStaticMarkup)return a.push(x(b)),!1;""===b?a=d:(d&&a.push("\x3c!-- --\x3e"),a.push(x(b)),a=!0);return a}
var Gc=Symbol.for("react.element"),Hc=Symbol.for("react.portal"),Ic=Symbol.for("react.fragment"),Jc=Symbol.for("react.strict_mode"),Kc=Symbol.for("react.profiler"),Lc=Symbol.for("react.provider"),Mc=Symbol.for("react.context"),Nc=Symbol.for("react.server_context"),Oc=Symbol.for("react.forward_ref"),Pc=Symbol.for("react.suspense"),Qc=Symbol.for("react.suspense_list"),Rc=Symbol.for("react.memo"),md=Symbol.for("react.lazy"),nd=Symbol.for("react.scope"),od=Symbol.for("react.debug_trace_mode"),pd=Symbol.for("react.offscreen"),
qd=Symbol.for("react.legacy_hidden"),rd=Symbol.for("react.cache"),sd=Symbol.for("react.default_value"),td=Symbol.for("react.memo_cache_sentinel"),ud=Symbol.for("react.postpone"),vd=Symbol.iterator;
function wd(a){if(null==a)return null;if("function"===typeof a)return a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case Ic:return"Fragment";case Hc:return"Portal";case Kc:return"Profiler";case Jc:return"StrictMode";case Pc:return"Suspense";case Qc:return"SuspenseList";case rd:return"Cache"}if("object"===typeof a)switch(a.$$typeof){case Mc:return(a.displayName||"Context")+".Consumer";case Lc:return(a._context.displayName||"Context")+".Provider";case Oc:var b=a.render;a=a.displayName;
a||(a=b.displayName||b.name||"",a=""!==a?"ForwardRef("+a+")":"ForwardRef");return a;case Rc:return b=a.displayName||null,null!==b?b:wd(a.type)||"Memo";case md:b=a._payload;a=a._init;try{return wd(a(b))}catch(c){break}case Nc:return(a.displayName||a._globalName)+".Provider"}return null}var xd={};function yd(a,b){a=a.contextTypes;if(!a)return xd;var c={},d;for(d in a)c[d]=b[d];return c}var zd=null;
function Ad(a,b){if(a!==b){a.context._currentValue2=a.parentValue;a=a.parent;var c=b.parent;if(null===a){if(null!==c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");}else{if(null===c)throw Error("The stacks must reach the root at the same time. This is a bug in React.");Ad(a,c)}b.context._currentValue2=b.value}}function Bd(a){a.context._currentValue2=a.parentValue;a=a.parent;null!==a&&Bd(a)}
function Cd(a){var b=a.parent;null!==b&&Cd(b);a.context._currentValue2=a.value}function Dd(a,b){a.context._currentValue2=a.parentValue;a=a.parent;if(null===a)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===b.depth?Ad(a,b):Dd(a,b)}
function Ed(a,b){var c=b.parent;if(null===c)throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");a.depth===c.depth?Ad(a,c):Ed(a,c);b.context._currentValue2=b.value}function Fd(a){var b=zd;b!==a&&(null===b?Cd(a):null===a?Bd(b):b.depth===a.depth?Ad(b,a):b.depth>a.depth?Dd(b,a):Ed(b,a),zd=a)}
var Gd={isMounted:function(){return!1},enqueueSetState:function(a,b){a=a._reactInternals;null!==a.queue&&a.queue.push(b)},enqueueReplaceState:function(a,b){a=a._reactInternals;a.replace=!0;a.queue=[b]},enqueueForceUpdate:function(){}};
function Hd(a,b,c,d){var e=void 0!==a.state?a.state:null;a.updater=Gd;a.props=c;a.state=e;var f={queue:[],replace:!1};a._reactInternals=f;var g=b.contextType;a.context="object"===typeof g&&null!==g?g._currentValue2:d;g=b.getDerivedStateFromProps;"function"===typeof g&&(g=g(c,e),e=null===g||void 0===g?e:r({},e,g),a.state=e);if("function"!==typeof b.getDerivedStateFromProps&&"function"!==typeof a.getSnapshotBeforeUpdate&&("function"===typeof a.UNSAFE_componentWillMount||"function"===typeof a.componentWillMount))if(b=
a.state,"function"===typeof a.componentWillMount&&a.componentWillMount(),"function"===typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount(),b!==a.state&&Gd.enqueueReplaceState(a,a.state,null),null!==f.queue&&0<f.queue.length)if(b=f.queue,g=f.replace,f.queue=null,f.replace=!1,g&&1===b.length)a.state=b[0];else{f=g?b[0]:a.state;e=!0;for(g=g?1:0;g<b.length;g++){var h=b[g];h="function"===typeof h?h.call(a,f,c,d):h;null!=h&&(e?(e=!1,f=r({},f,h)):r(f,h))}a.state=f}else f.queue=null}
var Id={id:1,overflow:""};function Jd(a,b,c){var d=a.id;a=a.overflow;var e=32-Kd(d)-1;d&=~(1<<e);c+=1;var f=32-Kd(b)+e;if(30<f){var g=e-e%5;f=(d&(1<<g)-1).toString(32);d>>=g;e-=g;return{id:1<<32-Kd(b)+e|c<<e|d,overflow:f+a}}return{id:1<<f|c<<e|d,overflow:a}}var Kd=Math.clz32?Math.clz32:Ld,Md=Math.log,Nd=Math.LN2;function Ld(a){a>>>=0;return 0===a?32:31-(Md(a)/Nd|0)|0}var Od=Error("Suspense Exception: This is not a real error! It's an implementation detail of `use` to interrupt the current render. You must either rethrow it immediately, or move the `use` call outside of the `try/catch` block. Capturing without rethrowing will lead to unexpected behavior.\n\nTo handle async errors, wrap your component in an error boundary, or call the promise's `.catch` method and pass the result to `use`");
function Pd(){}function Qd(a,b,c){c=a[c];void 0===c?a.push(b):c!==b&&(b.then(Pd,Pd),b=c);switch(b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;default:if("string"!==typeof b.status)switch(a=b,a.status="pending",a.then(function(d){if("pending"===b.status){var e=b;e.status="fulfilled";e.value=d}},function(d){if("pending"===b.status){var e=b;e.status="rejected";e.reason=d}}),b.status){case "fulfilled":return b.value;case "rejected":throw b.reason;}Rd=b;throw Od;}}var Rd=null;
function Sd(){if(null===Rd)throw Error("Expected a suspended thenable. This is a bug in React. Please file an issue.");var a=Rd;Rd=null;return a}function Td(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var Ud="function"===typeof Object.is?Object.is:Td,R=null,Vd=null,Wd=null,Xd=null,Yd=null,S=null,Zd=!1,$d=!1,ae=0,be=0,ce=-1,de=0,ee=null,fe=null,ge=0;
function he(){if(null===R)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:\n1. You might have mismatching versions of React and the renderer (such as React DOM)\n2. You might be breaking the Rules of Hooks\n3. You might have more than one copy of React in the same app\nSee https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.");return R}
function ie(){if(0<ge)throw Error("Rendered more hooks than during the previous render");return{memoizedState:null,queue:null,next:null}}function je(){null===S?null===Yd?(Zd=!1,Yd=S=ie()):(Zd=!0,S=Yd):null===S.next?(Zd=!1,S=S.next=ie()):(Zd=!0,S=S.next);return S}function ke(a,b,c,d){for(;$d;)$d=!1,be=ae=0,ce=-1,de=0,ge+=1,S=null,c=a(b,d);le();return c}function me(){var a=ee;ee=null;return a}function le(){Xd=Wd=Vd=R=null;$d=!1;Yd=null;ge=0;S=fe=null}
function ne(a,b){return"function"===typeof b?b(a):b}function oe(a,b,c){R=he();S=je();if(Zd){var d=S.queue;b=d.dispatch;if(null!==fe&&(c=fe.get(d),void 0!==c)){fe.delete(d);d=S.memoizedState;do d=a(d,c.action),c=c.next;while(null!==c);S.memoizedState=d;return[d,b]}return[S.memoizedState,b]}a=a===ne?"function"===typeof b?b():b:void 0!==c?c(b):b;S.memoizedState=a;a=S.queue={last:null,dispatch:null};a=a.dispatch=pe.bind(null,R,a);return[S.memoizedState,a]}
function qe(a,b){R=he();S=je();b=void 0===b?null:b;if(null!==S){var c=S.memoizedState;if(null!==c&&null!==b){var d=c[1];a:if(null===d)d=!1;else{for(var e=0;e<d.length&&e<b.length;e++)if(!Ud(b[e],d[e])){d=!1;break a}d=!0}if(d)return c[0]}}a=a();S.memoizedState=[a,b];return a}
function pe(a,b,c){if(25<=ge)throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");if(a===R)if($d=!0,a={action:c,next:null},null===fe&&(fe=new Map),c=fe.get(b),void 0===c)fe.set(b,a);else{for(b=c;null!==b.next;)b=b.next;b.next=a}}function re(){throw Error("A function wrapped in useEffectEvent can't be called during rendering.");}function se(){throw Error("startTransition cannot be called during server rendering.");}
function te(){throw Error("Cannot update optimistic state while rendering.");}function ue(a){var b=de;de+=1;null===ee&&(ee=[]);return Qd(ee,a,b)}function ve(){throw Error("Cache cannot be refreshed during server rendering.");}function we(){}
var ye={readContext:function(a){return a._currentValue2},use:function(a){if(null!==a&&"object"===typeof a){if("function"===typeof a.then)return ue(a);if(a.$$typeof===Mc||a.$$typeof===Nc)return a._currentValue2}throw Error("An unsupported type was passed to use(): "+String(a));},useContext:function(a){he();return a._currentValue2},useMemo:qe,useReducer:oe,useRef:function(a){R=he();S=je();var b=S.memoizedState;return null===b?(a={current:a},S.memoizedState=a):b},useState:function(a){return oe(ne,a)},
useInsertionEffect:we,useLayoutEffect:we,useCallback:function(a,b){return qe(function(){return a},b)},useImperativeHandle:we,useEffect:we,useDebugValue:we,useDeferredValue:function(a,b){he();return void 0!==b?b:a},useTransition:function(){he();return[!1,se]},useId:function(){var a=Vd.treeContext;var b=a.overflow;a=a.id;a=(a&~(1<<32-Kd(a)-1)).toString(32)+b;var c=xe;if(null===c)throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");b=ae++;a=":"+c.idPrefix+
"R"+a;0<b&&(a+="H"+b.toString(32));return a+":"},useSyncExternalStore:function(a,b,c){if(void 0===c)throw Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");return c()},useCacheRefresh:function(){return ve},useEffectEvent:function(){return re},useMemoCache:function(a){for(var b=Array(a),c=0;c<a;c++)b[c]=td;return b},useHostTransitionStatus:function(){he();return Ma},useOptimistic:function(a){he();return[a,te]},useFormState:function(a,
b,c){he();var d=be++,e=Wd;if("function"===typeof a.$$FORM_ACTION){var f=null,g=Xd;e=e.formState;var h=a.$$IS_SIGNATURE_EQUAL;if(null!==e&&"function"===typeof h){var k=e[1];h.call(a,e[2],e[3])&&(f=void 0!==c?"p"+c:"k"+ja(JSON.stringify([g,null,d]),0),k===f&&(ce=d,b=e[0]))}var l=a.bind(null,b);a=function(q){l(q)};"function"===typeof l.$$FORM_ACTION&&(a.$$FORM_ACTION=function(q){q=l.$$FORM_ACTION(q);void 0!==c&&(c+="",q.action=c);var m=q.data;m&&(null===f&&(f=void 0!==c?"p"+c:"k"+ja(JSON.stringify([g,
null,d]),0)),m.append("$ACTION_KEY",f));return q});return[b,a]}var n=a.bind(null,b);return[b,function(q){n(q)}]}},xe=null,ze={getCacheSignal:function(){throw Error("Not implemented.");},getCacheForType:function(){throw Error("Not implemented.");}},Ae=La.ReactCurrentDispatcher,Be=La.ReactCurrentCache;function De(a){console.error(a);return null}function Ee(){}
function Fe(a,b,c,d,e,f,g,h,k,l,n,q){Na.current=lb;var m=[],B=new Set;b={destination:null,flushScheduled:!1,resumableState:b,renderState:c,rootFormatContext:d,progressiveChunkSize:void 0===e?12800:e,status:0,fatalError:null,nextSegmentId:0,allPendingTasks:0,pendingRootTasks:0,completedRootSegment:null,abortableTasks:B,pingedTasks:m,clientRenderedBoundaries:[],completedBoundaries:[],partialBoundaries:[],trackedPostpones:null,onError:void 0===f?De:f,onPostpone:void 0===n?Ee:n,onAllReady:void 0===g?
Ee:g,onShellReady:void 0===h?Ee:h,onShellError:void 0===k?Ee:k,onFatalError:void 0===l?Ee:l,formState:void 0===q?null:q};c=Ge(b,0,null,d,!1,!1);c.parentFlushed=!0;a=He(b,null,a,-1,null,c,B,null,d,xd,null,Id);m.push(a);return b}var O=null;function Ie(a,b){a.pingedTasks.push(b);1===a.pingedTasks.length&&(a.flushScheduled=null!==a.destination,Je(a))}
function Ke(a,b){return{status:0,rootSegmentID:-1,parentFlushed:!1,pendingTasks:0,completedSegments:[],byteSize:0,fallbackAbortableTasks:b,errorDigest:null,resources:{styles:new Set,stylesheets:new Set},trackedContentKeyPath:null,trackedFallbackNode:null}}
function He(a,b,c,d,e,f,g,h,k,l,n,q){a.allPendingTasks++;null===e?a.pendingRootTasks++:e.pendingTasks++;var m={replay:null,node:c,childIndex:d,ping:function(){return Ie(a,m)},blockedBoundary:e,blockedSegment:f,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:n,treeContext:q,thenableState:b};g.add(m);return m}
function Le(a,b,c,d,e,f,g,h,k,l,n,q){a.allPendingTasks++;null===f?a.pendingRootTasks++:f.pendingTasks++;c.pendingTasks++;var m={replay:c,node:d,childIndex:e,ping:function(){return Ie(a,m)},blockedBoundary:f,blockedSegment:null,abortSet:g,keyPath:h,formatContext:k,legacyContext:l,context:n,treeContext:q,thenableState:b};g.add(m);return m}function Ge(a,b,c,d,e,f){return{status:0,id:-1,index:b,parentFlushed:!1,chunks:[],children:[],parentFormatContext:d,boundary:c,lastPushedText:e,textEmbedded:f}}
function W(a,b){a=a.onError(b);if(null!=a&&"string"!==typeof a)throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "'+typeof a+'" instead');return a}function Me(a,b){var c=a.onShellError;c(b);c=a.onFatalError;c(b);null!==a.destination?(a.status=2,a.destination.destroy(b)):(a.status=1,a.fatalError=b)}
function Ne(a,b,c,d,e){var f=d.render(),g=e.childContextTypes;if(null!==g&&void 0!==g){c=b.legacyContext;if("function"!==typeof d.getChildContext)e=c;else{d=d.getChildContext();for(var h in d)if(!(h in g))throw Error((wd(e)||"Unknown")+'.getChildContext(): key "'+h+'" is not defined in childContextTypes.');e=r({},c,d)}b.legacyContext=e;X(a,b,null,f,-1);b.legacyContext=c}else e=b.keyPath,b.keyPath=c,X(a,b,null,f,-1),b.keyPath=e}
function Oe(a,b,c,d,e,f,g){var h=!1;if(0!==f&&null!==a.formState){var k=b.blockedSegment;if(null!==k){h=!0;k=k.chunks;for(var l=0;l<f;l++)l===g?k.push("\x3c!--F!--\x3e"):k.push("\x3c!--F--\x3e")}}f=b.keyPath;b.keyPath=c;e?(c=b.treeContext,b.treeContext=Jd(c,1,0),Y(a,b,d,-1),b.treeContext=c):h?Y(a,b,d,-1):X(a,b,null,d,-1);b.keyPath=f}function Pe(a,b){if(a&&a.defaultProps){b=r({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}
function Qe(a,b,c,d,e,f,g){if("function"===typeof e)if(e.prototype&&e.prototype.isReactComponent){d=yd(e,b.legacyContext);var h=e.contextType;h=new e(f,"object"===typeof h&&null!==h?h._currentValue2:d);Hd(h,e,f,d);Ne(a,b,c,h,e)}else{h=yd(e,b.legacyContext);R={};Vd=b;Wd=a;Xd=c;be=ae=0;ce=-1;de=0;ee=d;d=e(f,h);d=ke(e,f,d,h);g=0!==ae;var k=be,l=ce;"object"===typeof d&&null!==d&&"function"===typeof d.render&&void 0===d.$$typeof?(Hd(d,e,f,h),Ne(a,b,c,d,e)):Oe(a,b,c,d,g,k,l)}else if("string"===typeof e)if(d=
b.blockedSegment,null===d)d=f.children,h=b.formatContext,g=b.keyPath,b.formatContext=ob(h,e,f),b.keyPath=c,Y(a,b,d,-1),b.formatContext=h,b.keyPath=g;else{g=Rb(d.chunks,e,f,a.resumableState,a.renderState,b.formatContext,d.lastPushedText);d.lastPushedText=!1;h=b.formatContext;k=b.keyPath;b.formatContext=ob(h,e,f);b.keyPath=c;Y(a,b,g,-1);b.formatContext=h;b.keyPath=k;a:{b=d.chunks;a=a.resumableState;switch(e){case "title":case "style":case "script":case "area":case "base":case "br":case "col":case "embed":case "hr":case "img":case "input":case "keygen":case "link":case "meta":case "param":case "source":case "track":case "wbr":break a;
case "body":if(1>=h.insertionMode){a.hasBody=!0;break a}break;case "html":if(0===h.insertionMode){a.hasHtml=!0;break a}}b.push(Mb(e))}d.lastPushedText=!1}else{switch(e){case qd:case od:case Jc:case Kc:case Ic:e=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=e;return;case pd:"hidden"!==f.mode&&(e=b.keyPath,b.keyPath=c,X(a,b,null,f.children,-1),b.keyPath=e);return;case Qc:e=b.keyPath;b.keyPath=c;X(a,b,null,f.children,-1);b.keyPath=e;return;case nd:throw Error("ReactDOMServer does not yet support scope components.");
case Pc:a:if(null!==b.replay){e=b.keyPath;b.keyPath=c;c=f.children;try{Y(a,b,c,-1)}finally{b.keyPath=e}}else{l=b.keyPath;e=b.blockedBoundary;var n=b.blockedSegment;d=f.fallback;var q=f.children;f=new Set;g=Ke(a,f);null!==a.trackedPostpones&&(g.trackedContentKeyPath=c);k=Ge(a,n.chunks.length,g,b.formatContext,!1,!1);n.children.push(k);n.lastPushedText=!1;var m=Ge(a,0,null,b.formatContext,!1,!1);m.parentFlushed=!0;b.blockedBoundary=g;b.blockedSegment=m;a.renderState.boundaryResources=g.resources;b.keyPath=
c;try{if(Y(a,b,q,-1),a.renderState.generateStaticMarkup||m.lastPushedText&&m.textEmbedded&&m.chunks.push("\x3c!-- --\x3e"),m.status=1,Re(g,m),0===g.pendingTasks&&0===g.status){g.status=1;break a}}catch(B){m.status=4,g.status=4,"object"===typeof B&&null!==B&&B.$$typeof===ud?(a.onPostpone(B.message),h="POSTPONE"):h=W(a,B),g.errorDigest=h}finally{a.renderState.boundaryResources=e?e.resources:null,b.blockedBoundary=e,b.blockedSegment=n,b.keyPath=l}h=[c[0],"Suspense Fallback",c[2]];l=a.trackedPostpones;
null!==l&&(n=[h[1],h[2],[],null],l.workingMap.set(h,n),5===g.status?l.workingMap.get(c)[4]=n:g.trackedFallbackNode=n);b=He(a,null,d,-1,e,k,f,h,b.formatContext,b.legacyContext,b.context,b.treeContext);a.pingedTasks.push(b)}return}if("object"===typeof e&&null!==e)switch(e.$$typeof){case Oc:e=e.render;R={};Vd=b;Wd=a;Xd=c;be=ae=0;ce=-1;de=0;ee=d;d=e(f,g);f=ke(e,f,d,g);Oe(a,b,c,f,0!==ae,be,ce);return;case Rc:e=e.type;f=Pe(e,f);Qe(a,b,c,d,e,f,g);return;case Lc:h=f.children;d=b.keyPath;e=e._context;f=f.value;
g=e._currentValue2;e._currentValue2=f;k=zd;zd=f={parent:k,depth:null===k?0:k.depth+1,context:e,parentValue:g,value:f};b.context=f;b.keyPath=c;X(a,b,null,h,-1);a=zd;if(null===a)throw Error("Tried to pop a Context at the root of the app. This is a bug in React.");c=a.parentValue;a.context._currentValue2=c===sd?a.context._defaultValue:c;a=zd=a.parent;b.context=a;b.keyPath=d;return;case Mc:f=f.children;f=f(e._currentValue2);e=b.keyPath;b.keyPath=c;X(a,b,null,f,-1);b.keyPath=e;return;case md:h=e._init;
e=h(e._payload);f=Pe(e,f);Qe(a,b,c,d,e,f,void 0);return}throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: "+((null==e?e:typeof e)+"."));}}
function Se(a,b,c,d,e){var f=b.replay,g=b.blockedBoundary,h=Ge(a,0,null,b.formatContext,!1,!1);h.id=c;h.parentFlushed=!0;try{b.replay=null,b.blockedSegment=h,Y(a,b,d,e),h.status=1,null===g?a.completedRootSegment=h:(Re(g,h),g.parentFlushed&&a.partialBoundaries.push(g))}finally{b.replay=f,b.blockedSegment=null}}
function X(a,b,c,d,e){if(null!==b.replay&&"number"===typeof b.replay.slots)Se(a,b,b.replay.slots,d,e);else{b.node=d;b.childIndex=e;if("object"===typeof d&&null!==d){switch(d.$$typeof){case Gc:var f=d.type,g=d.key,h=d.props,k=d.ref,l=wd(f),n=null==g?-1===e?0:e:g;g=[b.keyPath,l,n];if(null!==b.replay)a:{var q=b.replay;e=q.nodes;for(d=0;d<e.length;d++){var m=e[d];if(n===m[1]){if(4===m.length){if(null!==l&&l!==m[0])throw Error("Expected the resume to render <"+m[0]+"> in this slot but instead it rendered <"+
l+">. The tree doesn't match so React will fallback to client rendering.");l=m[2];m=m[3];n=b.node;b.replay={nodes:l,slots:m,pendingTasks:1};try{Qe(a,b,g,c,f,h,k);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(p){if("object"===typeof p&&null!==p&&(p===Od||"function"===typeof p.then))throw b.node===n&&(b.replay=q),p;b.replay.pendingTasks--;
Te(a,b.blockedBoundary,p,l,m)}b.replay=q}else{if(f!==Pc)throw Error("Expected the resume to render <Suspense> in this slot but instead it rendered <"+(wd(f)||"Unknown")+">. The tree doesn't match so React will fallback to client rendering.");b:{c=void 0;f=m[5];k=m[2];q=m[3];l=null===m[4]?[]:m[4][2];m=null===m[4]?null:m[4][3];n=b.keyPath;var B=b.replay,C=b.blockedBoundary,P=h.children;h=h.fallback;var u=new Set,z=Ke(a,u);z.parentFlushed=!0;z.rootSegmentID=f;b.blockedBoundary=z;b.replay={nodes:k,slots:q,
pendingTasks:1};a.renderState.boundaryResources=z.resources;try{Y(a,b,P,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--;if(0===z.pendingTasks&&0===z.status){z.status=1;a.completedBoundaries.push(z);break b}}catch(p){z.status=4,"object"===typeof p&&null!==p&&p.$$typeof===ud?(a.onPostpone(p.message),c="POSTPONE"):c=W(a,p),
z.errorDigest=c,b.replay.pendingTasks--,a.clientRenderedBoundaries.push(z)}finally{a.renderState.boundaryResources=C?C.resources:null,b.blockedBoundary=C,b.replay=B,b.keyPath=n}h=Le(a,null,{nodes:l,slots:m,pendingTasks:0},h,-1,C,u,[g[0],"Suspense Fallback",g[2]],b.formatContext,b.legacyContext,b.context,b.treeContext);a.pingedTasks.push(h)}}e.splice(d,1);break a}}}else Qe(a,b,g,c,f,h,k);return;case Hc:throw Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
case md:h=d._init;d=h(d._payload);X(a,b,null,d,e);return}if(Ka(d)){Ue(a,b,d,e);return}null===d||"object"!==typeof d?h=null:(h=vd&&d[vd]||d["@@iterator"],h="function"===typeof h?h:null);if(h&&(h=h.call(d))){d=h.next();if(!d.done){g=[];do g.push(d.value),d=h.next();while(!d.done);Ue(a,b,g,e)}return}if("function"===typeof d.then)return X(a,b,null,ue(d),e);if(d.$$typeof===Mc||d.$$typeof===Nc)return X(a,b,null,d._currentValue2,e);e=Object.prototype.toString.call(d);throw Error("Objects are not valid as a React child (found: "+
("[object Object]"===e?"object with keys {"+Object.keys(d).join(", ")+"}":e)+"). If you meant to render a collection of children, use an array instead.");}"string"===typeof d?(e=b.blockedSegment,null!==e&&(e.lastPushedText=Fc(e.chunks,d,a.renderState,e.lastPushedText))):"number"===typeof d&&(e=b.blockedSegment,null!==e&&(e.lastPushedText=Fc(e.chunks,""+d,a.renderState,e.lastPushedText)))}}
function Ue(a,b,c,d){var e=b.keyPath;if(-1!==d&&(b.keyPath=[b.keyPath,"Fragment",d],null!==b.replay)){for(var f=b.replay,g=f.nodes,h=0;h<g.length;h++){var k=g[h];if(k[1]===d){d=k[2];k=k[3];b.replay={nodes:d,slots:k,pendingTasks:1};try{Ue(a,b,c,-1);if(1===b.replay.pendingTasks&&0<b.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");b.replay.pendingTasks--}catch(n){if("object"===typeof n&&
null!==n&&(n===Od||"function"===typeof n.then))throw n;b.replay.pendingTasks--;Te(a,b.blockedBoundary,n,d,k)}b.replay=f;g.splice(h,1);break}}b.keyPath=e;return}f=b.treeContext;g=c.length;if(null!==b.replay&&(h=b.replay.slots,null!==h&&"object"===typeof h)){for(k=0;k<g;k++){d=c[k];b.treeContext=Jd(f,g,k);var l=h[k];"number"===typeof l?(Se(a,b,l,d,k),delete h[k]):Y(a,b,d,k)}b.treeContext=f;b.keyPath=e;return}for(h=0;h<g;h++)k=c[h],b.treeContext=Jd(f,g,h),Y(a,b,k,h);b.treeContext=f;b.keyPath=e}
function Ve(a,b,c,d){d.status=5;var e=c.keyPath,f=c.blockedBoundary;if(null===f)d.id=a.nextSegmentId++,b.rootSlots=d.id,null!==a.completedRootSegment&&(a.completedRootSegment.status=5);else{if(null!==f&&0===f.status){f.status=5;f.rootSegmentID=a.nextSegmentId++;var g=f.trackedContentKeyPath;if(null===g)throw Error("It should not be possible to postpone at the root. This is a bug in React.");var h=f.trackedFallbackNode,k=[];if(g===e&&-1===c.childIndex){d.id=f.rootSegmentID;d=[g[1],g[2],k,f.rootSegmentID,
h,f.rootSegmentID];b.workingMap.set(g,d);We(d,g[0],b);return}var l=b.workingMap.get(g);void 0===l?(l=[g[1],g[2],k,null,h,f.rootSegmentID],b.workingMap.set(g,l),We(l,g[0],b)):(g=l,g[4]=h,g[5]=f.rootSegmentID)}-1===d.id&&(d.id=d.parentFlushed&&null!==f?f.rootSegmentID:a.nextSegmentId++);if(-1===c.childIndex)null===e?b.rootSlots=d.id:(c=b.workingMap.get(e),void 0===c?(c=[e[1],e[2],[],d.id],We(c,e[0],b)):c[3]=d.id);else{if(null===e)if(a=b.rootSlots,null===a)a=b.rootSlots={};else{if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");
}else if(f=b.workingMap,g=f.get(e),void 0===g)a={},g=[e[1],e[2],[],a],f.set(e,g),We(g,e[0],b);else if(a=g[3],null===a)a=g[3]={};else if("number"===typeof a)throw Error("It should not be possible to postpone both at the root of an element as well as a slot below. This is a bug in React.");a[c.childIndex]=d.id}}}
function Y(a,b,c,d){var e=b.formatContext,f=b.legacyContext,g=b.context,h=b.keyPath,k=b.treeContext,l=b.blockedSegment;if(null===l)try{return X(a,b,null,c,d)}catch(m){if(le(),d=m===Od?Sd():m,"object"===typeof d&&null!==d&&"function"===typeof d.then){c=d;d=me();a=Le(a,d,b.replay,b.node,b.childIndex,b.blockedBoundary,b.abortSet,b.keyPath,b.formatContext,b.legacyContext,b.context,b.treeContext).ping;c.then(a,a);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;Fd(g);return}}else{var n=
l.children.length,q=l.chunks.length;try{return X(a,b,null,c,d)}catch(m){if(le(),l.children.length=n,l.chunks.length=q,d=m===Od?Sd():m,"object"===typeof d&&null!==d){if("function"===typeof d.then){c=d;d=me();l=b.blockedSegment;n=Ge(a,l.chunks.length,null,b.formatContext,l.lastPushedText,!0);l.children.push(n);l.lastPushedText=!1;a=He(a,d,b.node,b.childIndex,b.blockedBoundary,n,b.abortSet,b.keyPath,b.formatContext,b.legacyContext,b.context,b.treeContext).ping;c.then(a,a);b.formatContext=e;b.legacyContext=
f;b.context=g;b.keyPath=h;b.treeContext=k;Fd(g);return}if(null!==a.trackedPostpones&&d.$$typeof===ud&&null!==b.blockedBoundary){c=a.trackedPostpones;a.onPostpone(d.message);d=b.blockedSegment;l=Ge(a,d.chunks.length,null,b.formatContext,d.lastPushedText,!0);d.children.push(l);d.lastPushedText=!1;Ve(a,c,b,l);b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;Fd(g);return}}}}b.formatContext=e;b.legacyContext=f;b.context=g;b.keyPath=h;b.treeContext=k;Fd(g);throw d;}
function Te(a,b,c,d,e){if("object"===typeof c&&null!==c&&c.$$typeof===ud){a.onPostpone(c.message);var f="POSTPONE"}else f=W(a,c);Xe(a,b,d,e,c,f)}function Ye(a){var b=a.blockedBoundary;a=a.blockedSegment;null!==a&&(a.status=3,Ze(this,b,a))}
function Xe(a,b,c,d,e,f){for(var g=0;g<c.length;g++){var h=c[g];if(4===h.length)Xe(a,b,h[2],h[3],e,f);else{h=h[5];var k=a,l=f,n=Ke(k,new Set);n.parentFlushed=!0;n.rootSegmentID=h;n.status=4;n.errorDigest=l;n.parentFlushed&&k.clientRenderedBoundaries.push(n)}}c.length=0;if(null!==d){if(null===b)throw Error("We should not have any resumable nodes in the shell. This is a bug in React.");4!==b.status&&(b.status=4,b.errorDigest=f,b.parentFlushed&&a.clientRenderedBoundaries.push(b));if("object"===typeof d)for(var q in d)delete d[q]}}
function $e(a,b,c){var d=a.blockedBoundary,e=a.blockedSegment;null!==e&&(e.status=3);if(null===d){if(1!==b.status&&2!==b.status){a=a.replay;if(null===a){W(b,c);Me(b,c);return}a.pendingTasks--;0===a.pendingTasks&&0<a.nodes.length&&(d=W(b,c),Xe(b,null,a.nodes,a.slots,c,d));b.pendingRootTasks--;0===b.pendingRootTasks&&af(b)}}else d.pendingTasks--,4!==d.status&&(d.status=4,d.errorDigest=W(b,c),d.parentFlushed&&b.clientRenderedBoundaries.push(d)),d.fallbackAbortableTasks.forEach(function(f){return $e(f,
b,c)}),d.fallbackAbortableTasks.clear();b.allPendingTasks--;0===b.allPendingTasks&&bf(b)}function af(a){null===a.trackedPostpones&&Dc(a.renderState,a.resumableState,!0);a.onShellError=Ee;a=a.onShellReady;a()}function bf(a){Dc(a.renderState,a.resumableState,null===a.trackedPostpones?!0:null===a.completedRootSegment||5!==a.completedRootSegment.status);a=a.onAllReady;a()}
function Re(a,b){if(0===b.chunks.length&&1===b.children.length&&null===b.children[0].boundary){var c=b.children[0];c.id=b.id;c.parentFlushed=!0;1===c.status&&Re(a,c)}else a.completedSegments.push(b)}
function Ze(a,b,c){if(null===b){if(null!==c&&c.parentFlushed){if(null!==a.completedRootSegment)throw Error("There can only be one root segment. This is a bug in React.");a.completedRootSegment=c}a.pendingRootTasks--;0===a.pendingRootTasks&&af(a)}else b.pendingTasks--,4!==b.status&&(0===b.pendingTasks?(0===b.status&&(b.status=1),null!==c&&c.parentFlushed&&1===c.status&&Re(b,c),b.parentFlushed&&a.completedBoundaries.push(b),1===b.status&&(b.fallbackAbortableTasks.forEach(Ye,a),b.fallbackAbortableTasks.clear())):
null!==c&&c.parentFlushed&&1===c.status&&(Re(b,c),1===b.completedSegments.length&&b.parentFlushed&&a.partialBoundaries.push(b)));a.allPendingTasks--;0===a.allPendingTasks&&bf(a)}
function Je(a){if(2!==a.status){var b=zd,c=Ae.current;Ae.current=ye;var d=Be.current;Be.current=ze;var e=O;O=a;var f=xe;xe=a.resumableState;try{var g=a.pingedTasks,h;for(h=0;h<g.length;h++){var k=g[h],l=a,n=k.blockedBoundary;l.renderState.boundaryResources=n?n.resources:null;var q=k.blockedSegment;if(null===q){var m=l;if(0!==k.replay.pendingTasks){Fd(k.context);try{var B=k.thenableState;k.thenableState=null;X(m,k,B,k.node,k.childIndex);if(1===k.replay.pendingTasks&&0<k.replay.nodes.length)throw Error("Couldn't find all resumable slots by key/index during replaying. The tree doesn't match so React will fallback to client rendering.");
k.replay.pendingTasks--;k.abortSet.delete(k);Ze(m,k.blockedBoundary,null)}catch(v){le();var C=v===Od?Sd():v;if("object"===typeof C&&null!==C&&"function"===typeof C.then){var P=k.ping;C.then(P,P);k.thenableState=me()}else k.replay.pendingTasks--,k.abortSet.delete(k),Te(m,k.blockedBoundary,C,k.replay.nodes,k.replay.slots),m.pendingRootTasks--,0===m.pendingRootTasks&&af(m),m.allPendingTasks--,0===m.allPendingTasks&&bf(m)}finally{m.renderState.boundaryResources=null}}}else a:{m=void 0;var u=q;if(0===
u.status){Fd(k.context);var z=u.children.length,p=u.chunks.length;try{var Z=k.thenableState;k.thenableState=null;X(l,k,Z,k.node,k.childIndex);l.renderState.generateStaticMarkup||u.lastPushedText&&u.textEmbedded&&u.chunks.push("\x3c!-- --\x3e");k.abortSet.delete(k);u.status=1;Ze(l,k.blockedBoundary,u)}catch(v){le();u.children.length=z;u.chunks.length=p;var t=v===Od?Sd():v;if("object"===typeof t&&null!==t){if("function"===typeof t.then){var T=k.ping;t.then(T,T);k.thenableState=me();break a}if(null!==
l.trackedPostpones&&t.$$typeof===ud){var D=l.trackedPostpones;k.abortSet.delete(k);l.onPostpone(t.message);Ve(l,D,k,u);Ze(l,k.blockedBoundary,u);break a}}k.abortSet.delete(k);u.status=4;var A=k.blockedBoundary;"object"===typeof t&&null!==t&&t.$$typeof===ud?(l.onPostpone(t.message),m="POSTPONE"):m=W(l,t);null===A?Me(l,t):(A.pendingTasks--,4!==A.status&&(A.status=4,A.errorDigest=m,A.parentFlushed&&l.clientRenderedBoundaries.push(A)));l.allPendingTasks--;0===l.allPendingTasks&&bf(l)}finally{l.renderState.boundaryResources=
null}}}}g.splice(0,h);null!==a.destination&&cf(a,a.destination)}catch(v){W(a,v),Me(a,v)}finally{xe=f,Ae.current=c,Be.current=d,c===ye&&Fd(b),O=e}}}
function df(a,b,c){c.parentFlushed=!0;switch(c.status){case 0:c.id=a.nextSegmentId++;case 5:var d=c.id;c.lastPushedText=!1;c.textEmbedded=!1;a=a.renderState;b.push('<template id="');b.push(a.placeholderPrefix);a=d.toString(16);b.push(a);return b.push('"></template>');case 1:c.status=2;var e=!0;d=c.chunks;var f=0;c=c.children;for(var g=0;g<c.length;g++){for(e=c[g];f<e.index;f++)b.push(d[f]);e=ef(a,b,e)}for(;f<d.length-1;f++)b.push(d[f]);f<d.length&&(e=b.push(d[f]));return e;default:throw Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
}}
function ef(a,b,c){var d=c.boundary;if(null===d)return df(a,b,c);d.parentFlushed=!0;if(4===d.status)return a.renderState.generateStaticMarkup||(d=d.errorDigest,b.push("\x3c!--$!--\x3e"),b.push("<template"),d&&(b.push(' data-dgst="'),d=x(d),b.push(d),b.push('"')),b.push("></template>")),df(a,b,c),a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e"),a;if(1!==d.status)return 0===d.status&&(d.rootSegmentID=a.nextSegmentId++),0<d.completedSegments.length&&a.partialBoundaries.push(d),Vb(b,a.renderState,
d.rootSegmentID),df(a,b,c),b.push("\x3c!--/$--\x3e");if(d.byteSize>a.progressiveChunkSize)return d.rootSegmentID=a.nextSegmentId++,a.completedBoundaries.push(d),Vb(b,a.renderState,d.rootSegmentID),df(a,b,c),b.push("\x3c!--/$--\x3e");c=d.resources;var e=a.renderState.boundaryResources;e&&(c.styles.forEach(Bc,e),c.stylesheets.forEach(Cc,e));a.renderState.generateStaticMarkup||b.push("\x3c!--$--\x3e");c=d.completedSegments;if(1!==c.length)throw Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
ef(a,b,c[0]);a=a.renderState.generateStaticMarkup?!0:b.push("\x3c!--/$--\x3e");return a}function ff(a,b,c){Wb(b,a.renderState,c.parentFormatContext,c.id);ef(a,b,c);return Xb(b,c.parentFormatContext)}
function gf(a,b,c){a.renderState.boundaryResources=c.resources;for(var d=c.completedSegments,e=0;e<d.length;e++)hf(a,b,c,d[e]);d.length=0;oc(b,c.resources,a.renderState);d=a.resumableState;a=a.renderState;e=c.rootSegmentID;c=c.resources;var f=a.stylesToHoist;a.stylesToHoist=!1;var g=0===d.streamingFormat;g?(b.push(a.startInlineScript),f?0===(d.instructions&2)?(d.instructions|=10,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
0===(d.instructions&8)?(d.instructions|=8,b.push('$RM=new Map;\n$RR=function(r,t,w){for(var u=$RC,n=$RM,p=new Map,q=document,g,b,h=q.querySelectorAll("link[data-precedence],style[data-precedence]"),v=[],k=0;b=h[k++];)"not all"===b.getAttribute("media")?v.push(b):("LINK"===b.tagName&&n.set(b.getAttribute("href"),b),p.set(b.dataset.precedence,g=b));b=0;h=[];var l,a;for(k=!0;;){if(k){var f=w[b++];if(!f){k=!1;b=0;continue}var c=!1,m=0;var d=f[m++];if(a=n.get(d)){var e=a._p;c=!0}else{a=q.createElement("link");a.href=d;a.rel="stylesheet";for(a.dataset.precedence=\nl=f[m++];e=f[m++];)a.setAttribute(e,f[m++]);e=a._p=new Promise(function(x,y){a.onload=x;a.onerror=y});n.set(d,a)}d=a.getAttribute("media");!e||"l"===e.s||d&&!matchMedia(d).matches||h.push(e);if(c)continue}else{a=v[b++];if(!a)break;l=a.getAttribute("data-precedence");a.removeAttribute("media")}c=p.get(l)||g;c===g&&(g=a);p.set(l,a);c?c.parentNode.insertBefore(a,c.nextSibling):(c=q.head,c.insertBefore(a,c.firstChild))}Promise.all(h).then(u.bind(null,r,t,""),u.bind(null,r,t,"Resource failed to load"))};$RR("')):
b.push('$RR("'):0===(d.instructions&2)?(d.instructions|=2,b.push('$RC=function(b,c,e){c=document.getElementById(c);c.parentNode.removeChild(c);var a=document.getElementById(b);if(a){b=a.previousSibling;if(e)b.data="$!",a.setAttribute("data-dgst",e);else{e=b.parentNode;a=b.nextSibling;var f=0;do{if(a&&8===a.nodeType){var d=a.data;if("/$"===d)if(0===f)break;else f--;else"$"!==d&&"$?"!==d&&"$!"!==d||f++}d=a.nextSibling;e.removeChild(a);a=d}while(a);for(;c.firstChild;)e.insertBefore(c.firstChild,a);b.data="$"}b._reactRetry&&b._reactRetry()}};$RC("')):
b.push('$RC("')):f?b.push('<template data-rri="" data-bid="'):b.push('<template data-rci="" data-bid="');d=e.toString(16);b.push(a.boundaryPrefix);b.push(d);g?b.push('","'):b.push('" data-sid="');b.push(a.segmentPrefix);b.push(d);f?g?(b.push('",'),uc(b,c)):(b.push('" data-sty="'),vc(b,c)):g&&b.push('"');d=g?b.push(")\x3c/script>"):b.push('"></template>');return Ub(b,a)&&d}
function hf(a,b,c,d){if(2===d.status)return!0;var e=d.id;if(-1===e){if(-1===(d.id=c.rootSegmentID))throw Error("A root segment ID must have been assigned by now. This is a bug in React.");return ff(a,b,d)}if(e===c.rootSegmentID)return ff(a,b,d);ff(a,b,d);c=a.resumableState;a=a.renderState;(d=0===c.streamingFormat)?(b.push(a.startInlineScript),0===(c.instructions&1)?(c.instructions|=1,b.push('$RS=function(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("')):
b.push('$RS("')):b.push('<template data-rsi="" data-sid="');b.push(a.segmentPrefix);e=e.toString(16);b.push(e);d?b.push('","'):b.push('" data-pid="');b.push(a.placeholderPrefix);b.push(e);b=d?b.push('")\x3c/script>'):b.push('"></template>');return b}
function cf(a,b){try{var c,d=a.completedRootSegment;if(null!==d)if(5!==d.status&&0===a.pendingRootTasks){var e=a.renderState;if((0!==a.allPendingTasks||null!==a.trackedPostpones)&&e.externalRuntimeScript){var f=e.externalRuntimeScript,g=a.resumableState,h=f.src,k=f.chunks;g.scriptResources.hasOwnProperty(h)||(g.scriptResources[h]=null,e.scripts.add(k))}var l=e.htmlChunks,n=e.headChunks;f=0;if(l){for(f=0;f<l.length;f++)b.push(l[f]);if(n)for(f=0;f<n.length;f++)b.push(n[f]);else{var q=L("head");b.push(q);
b.push(">")}}else if(n)for(f=0;f<n.length;f++)b.push(n[f]);var m=e.charsetChunks;for(f=0;f<m.length;f++)b.push(m[f]);m.length=0;e.preconnects.forEach(M,b);e.preconnects.clear();var B=e.preconnectChunks;for(f=0;f<B.length;f++)b.push(B[f]);B.length=0;e.fontPreloads.forEach(M,b);e.fontPreloads.clear();e.highImagePreloads.forEach(M,b);e.highImagePreloads.clear();e.styles.forEach(rc,b);var C=e.importMapChunks;for(f=0;f<C.length;f++)b.push(C[f]);C.length=0;e.bootstrapScripts.forEach(M,b);e.scripts.forEach(M,
b);e.scripts.clear();e.bulkPreloads.forEach(M,b);e.bulkPreloads.clear();var P=e.preloadChunks;for(f=0;f<P.length;f++)b.push(P[f]);P.length=0;var u=e.hoistableChunks;for(f=0;f<u.length;f++)b.push(u[f]);u.length=0;if(l&&null===n){var z=Mb("head");b.push(z)}ef(a,b,d);a.completedRootSegment=null;Ub(b,a.renderState)}else return;var p=a.renderState;d=0;p.preconnects.forEach(M,b);p.preconnects.clear();var Z=p.preconnectChunks;for(d=0;d<Z.length;d++)b.push(Z[d]);Z.length=0;p.fontPreloads.forEach(M,b);p.fontPreloads.clear();
p.highImagePreloads.forEach(M,b);p.highImagePreloads.clear();p.styles.forEach(tc,b);p.scripts.forEach(M,b);p.scripts.clear();p.bulkPreloads.forEach(M,b);p.bulkPreloads.clear();var t=p.preloadChunks;for(d=0;d<t.length;d++)b.push(t[d]);t.length=0;var T=p.hoistableChunks;for(d=0;d<T.length;d++)b.push(T[d]);T.length=0;var D=a.clientRenderedBoundaries;for(c=0;c<D.length;c++){var A=D[c];p=b;var v=a.resumableState,Pa=a.renderState,qb=A.rootSegmentID,Ba=A.errorDigest,ka=A.errorMessage,da=A.errorComponentStack,
U=0===v.streamingFormat;U?(p.push(Pa.startInlineScript),0===(v.instructions&4)?(v.instructions|=4,p.push('$RX=function(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};;$RX("')):p.push('$RX("')):p.push('<template data-rxi="" data-bid="');p.push(Pa.boundaryPrefix);var Qa=qb.toString(16);p.push(Qa);U&&p.push('"');if(Ba||ka||da)if(U){p.push(",");var Ra=hc(Ba||"");p.push(Ra)}else{p.push('" data-dgst="');
var Sa=x(Ba||"");p.push(Sa)}if(ka||da)if(U){p.push(",");var la=hc(ka||"");p.push(la)}else{p.push('" data-msg="');var N=x(ka||"");p.push(N)}if(da)if(U){p.push(",");var rb=hc(da);p.push(rb)}else{p.push('" data-stck="');var ma=x(da);p.push(ma)}if(U?!p.push(")\x3c/script>"):!p.push('"></template>')){a.destination=null;c++;D.splice(0,c);return}}D.splice(0,c);var na=a.completedBoundaries;for(c=0;c<na.length;c++)if(!gf(a,b,na[c])){a.destination=null;c++;na.splice(0,c);return}na.splice(0,c);var aa=a.partialBoundaries;
for(c=0;c<aa.length;c++){var oa=aa[c];a:{D=a;A=b;D.renderState.boundaryResources=oa.resources;var pa=oa.completedSegments;for(v=0;v<pa.length;v++)if(!hf(D,A,oa,pa[v])){v++;pa.splice(0,v);var Ta=!1;break a}pa.splice(0,v);Ta=oc(A,oa.resources,D.renderState)}if(!Ta){a.destination=null;c++;aa.splice(0,c);return}}aa.splice(0,c);var qa=a.completedBoundaries;for(c=0;c<qa.length;c++)if(!gf(a,b,qa[c])){a.destination=null;c++;qa.splice(0,c);return}qa.splice(0,c)}finally{0===a.allPendingTasks&&0===a.pingedTasks.length&&
0===a.clientRenderedBoundaries.length&&0===a.completedBoundaries.length&&(a.flushScheduled=!1,null===a.trackedPostpones&&(c=a.resumableState,c.hasBody&&(aa=Mb("body"),b.push(aa)),c.hasHtml&&(c=Mb("html"),b.push(c))),b.push(null),a.destination=null)}}function jf(a){a.flushScheduled=null!==a.destination;Je(a);null===a.trackedPostpones&&Dc(a.renderState,a.resumableState,0===a.pendingRootTasks)}
function yc(a){if(!1===a.flushScheduled&&0===a.pingedTasks.length&&null!==a.destination){a.flushScheduled=!0;var b=a.destination;b?cf(a,b):a.flushScheduled=!1}}function kf(a,b){if(1===a.status)a.status=2,b.destroy(a.fatalError);else if(2!==a.status&&null===a.destination){a.destination=b;try{cf(a,b)}catch(c){W(a,c),Me(a,c)}}}
function lf(a,b){try{var c=a.abortableTasks;if(0<c.size){var d=void 0===b?Error("The render was aborted by the server without a reason."):b;c.forEach(function(e){return $e(e,a,d)});c.clear()}null!==a.destination&&cf(a,a.destination)}catch(e){W(a,e),Me(a,e)}}function We(a,b,c){if(null===b)c.rootNodes.push(a);else{var d=c.workingMap,e=d.get(b);void 0===e&&(e=[b[1],b[2],[],null],d.set(b,e),We(e,b[0],c));e[2].push(a)}}function mf(){}
function nf(a,b,c,d){var e=!1,f=null,g="",h=!1;b=mb(b?b.identifierPrefix:void 0,void 0);a=Fe(a,b,Ec(b,c),nb(),Infinity,mf,void 0,function(){h=!0},void 0,void 0,void 0);jf(a);lf(a,d);kf(a,{push:function(k){null!==k&&(g+=k);return!0},destroy:function(k){e=!0;f=k}});if(e&&f!==d)throw f;if(!h)throw Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");return g}
function of(a,b){a.prototype=Object.create(b.prototype);a.prototype.constructor=a;a.__proto__=b}var pf=function(a){function b(){var d=a.call(this,{})||this;d.request=null;d.startedFlowing=!1;return d}of(b,a);var c=b.prototype;c._destroy=function(d,e){lf(this.request);e(d)};c._read=function(){this.startedFlowing&&kf(this.request,this)};return b}(ia.Readable);function qf(){}
function rf(a,b){var c=new pf;b=mb(b?b.identifierPrefix:void 0,void 0);var d=Fe(a,b,Ec(b,!1),nb(),Infinity,qf,function(){c.startedFlowing=!0;kf(d,c)},void 0,void 0,void 0);c.request=d;jf(d);return c}exports.renderToNodeStream=function(a,b){return rf(a,b)};exports.renderToStaticMarkup=function(a,b){return nf(a,b,!0,'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.renderToStaticNodeStream=function(a,b){return rf(a,b)};exports.renderToString=function(a,b){return nf(a,b,!1,'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server')};
exports.version="18.3.0-experimental-2983249dd-20231107";
